#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <EzGraph.h>
#include "config.h"
#include "layout.h"
#include "draw.h"
#include "game.h"
#include "obj_draw.h"
#include "title_draw.h"
#include "howtoplay_draw.h"
#include "select_stage_draw.h"
#include "stage.h"
#include "stage_info_draw.h"
#include "gameclear_draw.h"
#include "gameover_draw.h"
#include "font.h"
#include "game.h"
#include "obj.h"

#include "xpm/titles.xpm"

rgb_t colors[] = {
    {  0,   0,   0},
    {  0,   0, 255},
    {255,   0,   0},
    {255,   0, 255},
    {  0, 255,   0},
    {  0, 255, 255},
    {255, 255,   0},
    {255, 255, 255},
};

font_id_t msg_score[] = {
    fi_to, fi_ku, fi_te, fi_n, fi_end
};
font_id_t msg_left[] = {
    fi_no, fi_ko, fi_ri, fi_end
};

font_id_t msg_test1[] = {
    fi_ti, fi_ku, fi_ti, fi_ku, fi_end
};
font_id_t msg_agyo[] = {
    fi_a, fi_i, fi_u, fi_e, fi_o, fi_end
};
font_id_t msg_kagyo[] = {
    fi_ka, fi_ki, fi_ku, fi_ke, fi_ko, fi_end
};
font_id_t msg_gagyo[] = {
    fi_ga, fi_gi, fi_gu, fi_ge, fi_go, fi_end
};
font_id_t msg_sagyo[] = {
    fi_sa, fi_si, fi_su, fi_se, fi_so, fi_end
};
font_id_t msg_zagyo[] = {
    fi_za, fi_zi, fi_zu, fi_ze, fi_zo, fi_end
};
font_id_t msg_tagyo[] = {
    fi_ta, fi_ti, fi_tu, fi_te, fi_to, fi_end
};
font_id_t msg_dagyo[] = {
    fi_da, fi_di, fi_du, fi_de, fi_do, fi_end
};
font_id_t msg_nagyo[] = {
    fi_na, fi_ni, fi_nu, fi_ne, fi_no, fi_end
};
font_id_t msg_hagyo[] = {
    fi_ha, fi_hi, fi_hu, fi_he, fi_ho, fi_end
};
font_id_t msg_bagyo[] = {
    fi_ba, fi_bi, fi_bu, fi_be, fi_bo, fi_end
};
font_id_t msg_pagyo[] = {
    fi_pa, fi_pi, fi_pu, fi_pe, fi_po, fi_end
};
font_id_t msg_magyo[] = {
    fi_ma, fi_mi, fi_mu, fi_me, fi_mo, fi_end
};
font_id_t msg_yagyo[] = {
    fi_ya, fi_i, fi_yu, fi_e, fi_yo, fi_end
};
font_id_t msg_ragyo[] = {
    fi_ra, fi_ri, fi_ru, fi_re, fi_ro, fi_end
};
font_id_t msg_wagyo[] = {
    fi_wa, fi_wo, fi_dash, fi_n, fi_end
};
font_id_t msg_lagyo[] = {
    fi_la, fi_li, fi_lu, fi_le, fi_lo, fi_end
};
font_id_t msg_num1[] = {
    fi_n0, fi_n1, fi_n2, fi_n3, fi_n4, fi_end
};
font_id_t msg_lyagyo[] = {
    fi_lya, fi_li, fi_lyu, fi_le, fi_lyo, fi_end
};
font_id_t msg_num2[] = {
    fi_n5, fi_n6, fi_n7, fi_n8, fi_n9, fi_end
};
font_id_t msg_test3[] = {
    fi_ti, fi_ku, fi_ti, fi_ku, fi_end
};

static EzImage title_img;

static char *gondin_str = "Ǥ";
static font_id_t *gondin_fontseq;
static char *gondin_toeat_str = "Τ";
static char *gondin_eaten_str = "٤";
//  Ⱦ˿ͤΤǡŪ˳
static font_id_t gondin_toeat_fontseq[10];
static font_id_t gondin_eaten_fontseq[10];
static char *stage_str = "ơ";
// stageϸȾ˥ơֹΤǡŪ˳
static font_id_t stage_fontseq[10];

//static char *score_str = "ȤƤ";
//tatic font_id_t *score_fontseq;
//static font_id_t score_val_fontseq[10];
static char *time_str = "";
static font_id_t *time_fontseq;
static font_id_t time_val_fontseq[GAME_TIME_LEN+1];

static char *pause_str = "[Ƥ]";
static font_id_t *pause_fontseq;
static char *pause_cont_str = "򤵤";
static font_id_t *pause_cont_fontseq;
static char *pause_quit_str = "Qơ󤿤";
static font_id_t *pause_quit_fontseq;
static char *objective_str = "⤯Ҥ礦";
static font_id_t *objective_fontseq;
static font_id_t objective_info_fontseqs[OBJECTIVE_NUM][10];


#define SLtx(x) ((x) + STATUS_XOFFSET)
#define SLty(y) ((y) + STATUS_YOFFSET)

static int gameclear_onoff = 0;
static int gameover_onoff = 0;
static int prev_time;

void draw_stage_result(void);
void draw_time(void);

void draw_init(void){
	obj_draw_init();
    font_init();
    title_draw_init();
    select_stage_draw_init();
    stage_info_draw_init();
    howtoplay_draw_init();
    gameclear_draw_init();
	gameover_draw_init();
    pause_fontseq = alloc_fontseq(pause_str);
    pause_cont_fontseq = alloc_fontseq(pause_cont_str);

	pause_quit_fontseq = alloc_fontseq(pause_quit_str);
    gondin_fontseq = alloc_fontseq(gondin_str);
	str2fontseq(stage_str, stage_fontseq);
	str2fontseq(gondin_toeat_str, gondin_toeat_fontseq);
	str2fontseq(gondin_eaten_str, gondin_eaten_fontseq);
//    score_fontseq = alloc_fontseq(score_str);
    time_fontseq = alloc_fontseq(time_str);
	objective_fontseq = alloc_fontseq(objective_str);
    title_img = EzReadXPM(title_s_xpm);
}

void setup_draw_screen(void){
    int i;
    objective_t *objective;

	uint2fontseq(get_current_stage_gondin_toeat(), 5, gondin_toeat_fontseq+3);
	uint2fontseq(0, 5, gondin_eaten_fontseq+3);
	uint2fontseq(get_current_stage_no(), 5, stage_fontseq+4);
	uint2fontseq(GetTime(), GAME_TIME_LEN, time_val_fontseq);
    for (i = 0 ; i < OBJECTIVE_NUM ; i++){
        objective = get_stage_objective(i);
        if (objective->entry != re_invalid){
            objective_info_fontseqs[i][0]
                = objective->icon[0];
            objective_info_fontseqs[i][1] = fi_space;
            switch (objective->op){
            case oo_le:
                objective_info_fontseqs[i][2] = fi_op_le;
                break;
            case oo_ge:
                objective_info_fontseqs[i][2] = fi_op_ge;
                break;
            case oo_eq:
                objective_info_fontseqs[i][2] = fi_equal;
                break;
            default:
                break;
            }
            objective_info_fontseqs[i][3] = fi_space;
            uint2fontseq(objective->val, 4, &objective_info_fontseqs[i][4]);
        }
        else {
            objective_info_fontseqs[i][0] = fi_end;
        }
    }

    switch_draw_gameclear(0);
    switch_draw_gameover(0);
	prev_time = GetTime();
}

void switch_draw_gameclear(int onoff){
    gameclear_onoff = onoff;
}
void switch_draw_gameover(int onoff){
    gameover_onoff = onoff;
}

void draw_screen(void){
	int i;
  
    EzPutB(SLtx(0)-16, 4, title_img);

    draw_fontseq(SLtx(0), SLty(0), stage_fontseq);
    for (i = 0 ; i < STAGE_TITLE_ROW_NUM ; i++){
	    draw_fontseq(SLtx(16), SLty(LINESKIP*(i+1)),
                     get_current_stage_title(i));
    }
//    draw_fontseq(SLtx(0), SLty(LINESKIP*4), score_fontseq);
//	uint2fontseq(12234, 9, score_val_fontseq);
//    draw_fontseq(SLtx(0), SLty(LINESKIP*5), score_val_fontseq);
    draw_fontseq(SLtx(0), SLty(LINESKIP*3), gondin_fontseq);
//	uint2fontseq(12234, 9, score_val_fontseq);
    draw_fontseq(SLtx(16), SLty(LINESKIP*4), gondin_toeat_fontseq);
    draw_fontseq(SLtx(16), SLty(LINESKIP*5), gondin_eaten_fontseq);

    draw_fontseq(SLtx(0), SLty(LINESKIP*6), time_fontseq);
    if (prev_time != GetTime()){
        dec_fontseq(GAME_TIME_LEN, time_val_fontseq);
        prev_time = GetTime();
    }
    draw_fontseq(SLtx(0)+16*6, SLty(LINESKIP*7), time_val_fontseq);
    draw_fontseq(SLtx(0), SLty(LINESKIP*8), objective_fontseq);

    for (i = 0 ; i < OBJECTIVE_NUM ; i++){
		if (objective_info_fontseqs[i][0] != fi_end){
			draw_fontseq(SLtx(0), SLty(LINESKIP*(9+i)), game.objectives[i].stat_fontseq);
		    draw_fontseq(SLtx(0)+16, SLty(LINESKIP*(9+i)), 
			             objective_info_fontseqs[i]);
		}
    }


//    draw_fontseq(SLtx(0), SLty(LINESKIP*8), gondin_fontseq);

	if (get_current_stage_sign_no() != INVALID_LINK_NO){
	    for (i = 0 ; i < STAGE_SIGN_ROW_NUM ; i++){
		    draw_fontseq(SLtx(16), SLty(LINESKIP*(i+12)),
			             get_current_stage_sign(i));
		}
	}

    draw_obj_list();
    if (GetShowHitMarker()){
        draw_hitmarker();
    }
    //    draw_fontseq(500,  8, msg_score);
    //    draw_fontseq(500, 28, msg_left);
	/*
    draw_fontseq(500, 48+20*1, msg_test1);
    draw_fontseq(500, 48+20*2, msg_agyo);
    draw_fontseq(500, 48+20*3, msg_kagyo);
    draw_fontseq(500, 48+20*4, msg_gagyo);
    draw_fontseq(500, 48+20*5, msg_sagyo);
    draw_fontseq(500, 48+20*6, msg_zagyo);
    draw_fontseq(500, 48+20*7, msg_tagyo);
    draw_fontseq(500, 48+20*8, msg_dagyo);
    draw_fontseq(500, 48+20*9, msg_nagyo);
    draw_fontseq(500, 48+20*10, msg_hagyo);
    draw_fontseq(500, 48+20*11, msg_bagyo);
    draw_fontseq(500, 48+20*12, msg_pagyo);
    draw_fontseq(500, 48+20*13, msg_magyo);
    draw_fontseq(500, 48+20*14, msg_yagyo);
    draw_fontseq(500, 48+20*15, msg_ragyo);
    draw_fontseq(500, 48+20*16, msg_wagyo);
    draw_fontseq(500, 48+20*17, msg_lagyo);
    draw_fontseq(500, 48+20*18, msg_lyagyo);
    draw_fontseq(500, 48+20*19, msg_num1);
    draw_fontseq(500, 48+20*20, msg_num2);
    //    draw_font(500, 16, fi_a);
    //    draw_font(516, 16, fi_te);
    //    draw_font(532, 16, fi_n);
	*/
    if (gameclear_onoff){
        draw_gameclear();
    }
    else if (gameover_onoff){
        draw_gameover();
    }
//    draw_time();
    EzShowBuffer();
}

void draw_pause_message(void){
    draw_fontseq(SLtx(0), SLty(LINESKIP*17), pause_fontseq);
    draw_fontseq(SLtx(0), SLty(LINESKIP*18), pause_cont_fontseq);
    draw_fontseq(SLtx(0), SLty(LINESKIP*19), pause_quit_fontseq);
}


void draw_time(void){
    char buf[12];

    
    sprintf(buf, "%2dfps", GetFramesPerSec());
    SetColor(7);
    EzDrawStringB(WIN_WIDTH - 8*5, 16, buf);
    //    puts(buf);
}

void inc_gondin_eaten_fontseq(void){
  inc_fontseq(5, gondin_eaten_fontseq+3);
}

