#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "config.h"
#include "emap.h"
#include "layout.h"
#include "uty.h"
#include "obj.h"

emap_e_t emap_static[MAP_HEIGHT][MAP_WIDTH];
emap_e_t emap[2][MAP_HEIGHT][MAP_WIDTH];
obj_t *emap_owner_static[32][MAP_HEIGHT][MAP_WIDTH];
obj_t *emap_owner[2][32][MAP_HEIGHT][MAP_WIDTH];

int current_emap = 0;

void emap_init(void){
    // ӥåȥեɤ32ӥåȤǼޤäƤ뤫å
    assert(eb_end < 32);
}

void clear_emap(void){
    memset(emap_static, 0, sizeof(emap_static));
    memset(emap, 0, sizeof(emap));
    memset(emap_owner_static, 0, sizeof(emap_owner_static));
    memset(emap_owner, 0, sizeof(emap_owner));
}

void clear_current_emap_owner(void){
    memset(emap_owner[current_emap], 0, sizeof(emap_owner)/2);
}

void setup_emap(void){
	// !! ǽstageΥ֥createdynamic emapĤ
	// orǥԡ롣
	// Ū˳ƥ֥Ȥset_emap_initƳ줿顢
	// createǤϤʤcp_staticƤset_emap_initƤǲ
	cp_or_static_emap();
}

void switch_current_emap(void){
    clear_current_emap_owner();
	current_emap = NextEMap;
    cp_static_emap();
}

void copy_emap(void){
    memcpy(emap[current_emap], emap[NextEMap], 
           sizeof(emap_static));	
}

void cp_static_emap(void){
    memcpy(emap[NextEMap], emap_static,
           sizeof(emap_static));
}
void cp_or_static_emap(void){
	char *np, *sp;
	int i;

	np = (char*)emap[NextEMap];
	sp = (char*)emap_static;
	for (i = 0 ; i < sizeof(emap_static) ; i++){
		*np |= *sp;
		np ++;
		sp ++;
	}
}

void set_emap_static_box(int ltx, int lty, int width, int height,
                         effect_bit_t bit)
{
    int x, y;
    unsigned int pat = 1 << (bit);

    for (y = lty ; y < lty+height ; y++){
        for (x = ltx ; x < ltx+width ; x++){
            emap_static[y][x] |= pat;
        }
    }
}
void set_emap_box(int ltx, int lty, int width, int height, effect_bit_t bit){
    int x, y;
    unsigned int pat = 1 << (bit);

    for (y = lty ; y < lty+height ; y++){
        for (x = ltx ; x < ltx+width ; x++){
            emap[NextEMap][y][x] |= pat;
        }
    }
}
void reset_emap_box(int ltx, int lty, int width, int height, effect_bit_t bit){
    int x, y;
    unsigned int pat = ~(1 << (bit));

    for (y = lty ; y < lty+height ; y++){
        for (x = ltx ; x < ltx+width ; x++){
            emap[NextEMap][y][x] &= pat;
        }
    }
}

void set_emap_owner_box(int ltx, int lty, int width, int height, effect_bit_t eb, obj_t *obj){
    int x, y;

    for (y = lty ; y < lty+height ; y++){
        for (x = ltx ; x < ltx+width ; x++){
		    emap_owner[NextEMap][eb][y][x] = obj;
        }
    }
}

void set_emap_owner_static_box(int ltx, int lty, int width, int height, effect_bit_t eb, obj_t *obj){
    int x, y;

    for (y = lty ; y < lty+height ; y++){
        for (x = ltx ; x < ltx+width ; x++){
		    emap_owner_static[eb][y][x] = obj;
        }
    }
}

void set_emap_static_blockbox(int ltx, int lty, int width, int height){
    int x, y;
    // Ūˤϳ饤˥֥å°ꤹ뤬
    // ȴɻߤΤᡢʪΤ¦ˤ1饤󤺤ꤷƤ
	// ޥå׺ǳ¦wallϰϳǽ뤿ᡢ
	// ϰϥåɬסδؿƤФΤϥ೫ΤߤʤΤ
	// Хإåɤϵˤʤɤ
    for (x = ltx ; x < ltx + width ; x++){
        if (lty > 0) SetEMapStatic(x, lty-1, eb_block_down);    
        SetEMapStatic(x, lty, eb_exclude_up);    
        SetEMapStatic(x, lty+1, eb_exclude_up);    
        SetEMapStatic(x, lty+height-2, eb_exclude_down);    
        SetEMapStatic(x, lty+height-1, eb_exclude_down);    
        if (lty+height < MAP_HEIGHT) SetEMapStatic(x, lty+height, eb_block_up);    
    }
    for (y = lty ; y < lty + height ; y++){
        if (ltx > 0) SetEMapStatic(ltx-1, y, eb_block_right);    
        SetEMapStatic(ltx, y, eb_exclude_left);    
        SetEMapStatic(ltx+1, y, eb_exclude_left);    
        SetEMapStatic(ltx+width-2, y, eb_exclude_right); 
        SetEMapStatic(ltx+width-1, y, eb_exclude_right); 
        if (ltx+width < MAP_WIDTH) SetEMapStatic(ltx+width, y, eb_block_left); 
    }
}

void reset_emap_static_blockbox(int ltx, int lty, int width, int height){
    int x, y;
    // Ūˤϳ饤˥֥å°ꤹ뤬
    // ȴɻߤΤᡢʪΤ¦ˤ1饤󤺤ꤷƤ
    for (x = ltx ; x < ltx + width ; x++){
        if (lty > 0) ResetEMapStatic(x, lty-1, eb_block_down);    
        ResetEMapStatic(x, lty, eb_exclude_up);    
        ResetEMapStatic(x, lty+1, eb_exclude_up);    
        ResetEMapStatic(x, lty+height-2, eb_exclude_down);    
        ResetEMapStatic(x, lty+height-1, eb_exclude_down);    
        if (lty+height < MAP_HEIGHT) ResetEMapStatic(x, lty+height, eb_block_up);    
    }
    for (y = lty ; y < lty + height ; y++){
        if (ltx > 0) ResetEMapStatic(ltx-1, y, eb_block_right);    
        ResetEMapStatic(ltx, y, eb_exclude_left);    
        ResetEMapStatic(ltx+1, y, eb_exclude_left);    
        ResetEMapStatic(ltx+width-2, y, eb_exclude_right); 
        ResetEMapStatic(ltx+width-1, y, eb_exclude_right); 
        if (ltx+width < MAP_WIDTH) ResetEMapStatic(ltx+width, y, eb_block_left); 
    }
}

void set_emap_blockbox(int ltx, int lty, int width, int height){
    int x, y;
    // Ūˤϳ饤˥֥å°ꤹ뤬
    // ȴɻߤΤᡢʪΤ¦ˤ1饤󤺤ꤷƤ
	// ʬ˥åʤɤ֤
	// ϰϳåƤ
	// ѾʤȻפ뤬Хإåɤ礭褦ʤ顢
	// emap˼1ԡ1󤺤ĤΥޡ줿⤷ʤ
    for (x = ltx ; x < ltx + width ; x++){
        if (lty > 0) SetEMap(x, lty-1, eb_block_down);    
        SetEMap(x, lty, eb_exclude_up);    
        SetEMap(x, lty+1, eb_exclude_up);    
        SetEMap(x, lty+height-2, eb_exclude_down);    
        SetEMap(x, lty+height-1, eb_exclude_down);    
        if (lty+height < MAP_HEIGHT) SetEMap(x, lty+height, eb_block_up);    
    }
    for (y = lty ; y < lty + height ; y++){
        if (ltx > 0) SetEMap(ltx-1, y, eb_block_right);    
        SetEMap(ltx, y, eb_exclude_left);    
        SetEMap(ltx+1, y, eb_exclude_left);    
        SetEMap(ltx+width-2, y, eb_exclude_right); 
        SetEMap(ltx+width-1, y, eb_exclude_right); 
        if (ltx+width < MAP_WIDTH) SetEMap(ltx+width, y, eb_block_left); 
    }
}

int check_emap_box_any(int ltx, int lty, int width, int height, 
					   effect_bit_t eb)
{
	int x, y;

    for (y = lty ; y < lty+height ; y++){
	    for (x = ltx ; x < ltx+width ; x++){
            //			if (CheckEMap(x, y, eb)) return 1;
            ReturnCheckEMapPos(x, y, eb);
		}
	}
	return 0;
}
int check_emap_obj_any(obj_t *obj, effect_bit_t eb){
	return check_emap_box_any(obj->x, obj->y, obj->width, obj->height, eb);
}
int check_emap_pos_box_any(int ltx, int lty, int width, int height, 
					       effect_bit_t eb)
{
	int x, y;

    for (y = lty ; y < lty+height ; y++){
	    for (x = ltx ; x < ltx+width ; x++){
			if (CheckEMap(x, y, eb)){
                assert(GetEMapOwner(x, y, eb) != NULL);
                return Pos2CheckVal(x, y);
            }
		}
	}
	return 0;
}
int check_emap_pos_obj_any(obj_t *obj, effect_bit_t eb){
	return check_emap_pos_box_any(obj->x, obj->y, obj->width, obj->height, eb);
}

int check_emap_box_any_corner(int ltx, int lty, int width, int height, effect_bit_t eb){
    if (CheckEMap(ltx, lty, eb) ||
        CheckEMap(ltx+width-1, lty, eb) ||
        CheckEMap(ltx, lty+height-1, eb) ||
        CheckEMap(ltx+width-1, lty+height-1, eb))
    {
        return 1;
    }
    else {
        return 0;
    }
}
int check_emap_obj_any_corner(obj_t *obj, effect_bit_t eb){
	return check_emap_box_any_corner(obj->x, obj->y, obj->width, obj->height, eb);
}
int check_emap_pos_box_any_corner(int ltx, int lty, int width, int height, effect_bit_t eb){
	ReturnCheckEMapPos(ltx,         lty, eb);
	ReturnCheckEMapPos(ltx+width-1, lty, eb);
	ReturnCheckEMapPos(ltx,         lty+height-1, eb);
	ReturnCheckEMapPos(ltx+width-1, lty+height-1, eb);
    return 0;

}
int check_emap_pos_obj_any_corner(obj_t *obj, effect_bit_t eb){
	return check_emap_pos_box_any_corner(obj->x, obj->y, obj->width, obj->height, eb);
}

int check_emap_box_all_corner(int ltx, int lty, int width, int height, effect_bit_t eb){
    if (CheckEMap(ltx, lty, eb) &&
        CheckEMap(ltx+width-1, lty, eb) &&
        CheckEMap(ltx, lty+height-1, eb) &&
        CheckEMap(ltx+width-1, lty+height-1, eb))
    {
        return 1;
    }
    else {
        return 0;
    }

}
int check_emap_obj_all_corner(obj_t *obj, effect_bit_t eb){
	return check_emap_box_all_corner(obj->x, obj->y, obj->width, obj->height, eb);
}

int check_emap_box_any_rim(int ltx, int lty, int width, int height, effect_bit_t eb){
    /*
	if (check_emap_box_any_left(ltx, lty, width, height, eb) ||
		check_emap_box_any_right(ltx, lty, width, height, eb) ||
		check_emap_box_any_up(ltx, lty, width, height, eb) ||
		check_emap_box_any_down(ltx, lty, width, height, eb))
	{
        return 1;
    }
    else {
        return 0;
    }
    */
    int v;
	if ((v = check_emap_box_any_left(ltx, lty, width, height, eb))) return v;
    if ((v = check_emap_box_any_right(ltx, lty, width, height, eb))) return v;
    if ((v = check_emap_box_any_up(ltx, lty, width, height, eb))) return v;
    if ((v = check_emap_box_any_down(ltx, lty, width, height, eb))) return v;
    return 0;
}
int check_emap_obj_any_rim(obj_t *obj, effect_bit_t eb){
	return check_emap_box_any_rim(obj->x, obj->y, obj->width, obj->height, eb);
}


int check_emap_box_any_left(int ltx, int lty, int width, int height,
                            effect_bit_t eb)
{
    int i;
	for (i = 0 ; i < height ; i++){
        ReturnCheckEMapPos(ltx, lty+i, eb);
    }
    return 0;
}
int check_emap_box_any_right(int ltx, int lty, int width, int height,
                             effect_bit_t eb)
{
    int i;
	for (i = 0 ; i < height ; i++){
        ReturnCheckEMapPos(ltx+width-1, lty+i, eb);
    }
    return 0;
}
int check_emap_box_any_up(int ltx, int lty, int width, int height,
                          effect_bit_t eb)
{
    int i;
	for (i = 0 ; i < width ; i++){
        ReturnCheckEMapPos(ltx+i, lty, eb);
    }
    return 0;
}
int check_emap_box_any_down(int ltx, int lty, int width, int height,
                            effect_bit_t eb)
{
    int i;
	for (i = 0 ; i < width ; i++){
        ReturnCheckEMapPos(ltx+i, lty+height-1, eb);
    }
    return 0;
}
int check_emap_obj_any_left(obj_t *obj, effect_bit_t eb){
	return check_emap_box_any_left(obj->x, obj->y, obj->width, obj->height, eb);
}
int check_emap_obj_any_right(obj_t *obj, effect_bit_t eb){
	return check_emap_box_any_right(obj->x, obj->y, obj->width, obj->height, eb);
}
int check_emap_obj_any_up(obj_t *obj, effect_bit_t eb){
	return check_emap_box_any_up(obj->x, obj->y, obj->width, obj->height, eb);
}
int check_emap_obj_any_down(obj_t *obj, effect_bit_t eb){
	return check_emap_box_any_down(obj->x, obj->y, obj->width, obj->height, eb);
}










int check_emap_dir(effect_bit_t eb, dir_t dir, obj_t *obj){
    switch(dir){
    case di_left:
        return check_emap_left(eb, obj);
    case di_right:
        return check_emap_right(eb, obj);
    case di_up:
        return check_emap_up(eb, obj);
    case di_down:
        return check_emap_down(eb, obj);
    default:
        assert(0);
        exit(1);
    }
}

int check_emap_left(effect_bit_t eb, obj_t *obj){
    //    emap_e_t e;
    int i, b=0;

    for (i = 0 ; i < obj->height ; i++){
        b |= CheckEMap(Ltx(obj), Lty(obj)+i, eb);
        /*
        e = GetEMapE(Ltx(obj), Lty(obj)+i);
        b |= (check_emap_element(e, eb) ? (1 << i) : 0);
        */
    }
    return b;
}
int check_emap_right(effect_bit_t eb, obj_t *obj){
    //    emap_e_t e;
    int i, b=0;

    for (i = 0 ; i < obj->height ; i++){
        b |= CheckEMap(Rtx(obj), Rty(obj)+i, eb);
        /*
        e = GetEMapE(Rtx(obj), Rty(obj)+i);
        b |= (check_emap_element(e, eb) ? (1 << i) : 0);
        */
    }
    return b;
}
int check_emap_up(effect_bit_t eb, obj_t *obj){
    //    emap_e_t e;
    int i, b=0;

    for (i = 0 ; i < obj->width ; i++){
        b |= CheckEMap(Ltx(obj)+i, Lty(obj), eb);
        /*
        e = GetEMapE(Ltx(obj)+i, Lty(obj));
        b |= (check_emap_element(e, eb) ? (1 << i) : 0);
        */
    }
    return b;
}
int check_emap_down(effect_bit_t eb, obj_t *obj){
    //    emap_e_t e;
    int i, b=0;

    for (i = 0 ; i < obj->width ; i++){
        b |= CheckEMap(Lbx(obj)+i, Lby(obj), eb);
        /*
        e = GetEMapE(Lbx(obj)+i, Lby(obj));
        b |= (check_emap_element(e, eb) ? (1 << i) : 0);
        */
    }
    return b;
}


int check_emap_any_rim(effect_bit_t eb, obj_t *obj){
    return check_emap_left(eb, obj) ||
		check_emap_right(eb, obj) ||
		check_emap_up(eb, obj) ||
		check_emap_down(eb, obj);
}





