#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <EzGraph.h>
#include "config.h"
#include "main.h"
#include "howtoplay.h"
#include "draw.h"
#include "howtoplay_draw.h"


static howtoplay_menuitem_t cursor_pos;

void howtoplay_init(void){
    cursor_pos = hi_keys;
}

howtoplay_menuitem_t howtoplay_mode(void){
	return cursor_pos;
}

void setup_howtoplay(void){
    EzSetKeyHandler(howtoplay_keyh);
    EzSetKeyReleaseHandler(howtoplay_key_releaseh);
    EzSetTimerHandler(howtoplay_timerh, GAME_SPEED);
}

void howtoplay_keyh(int key){
    switch (key){
    case EZ_Left:
    case EZ_Up:
        cursor_pos = (cursor_pos + hi_end - 1) % hi_end;
        break;
    case EZ_Right:
    case EZ_Down:
        cursor_pos = (cursor_pos + 1) % hi_end;
        break;
    default:
        break;
    }
}

void howtoplay_key_releaseh(int key){
    switch (key){
    case 'q':
	case 27:
    case ' ':
    case EZ_Return:
        set_main_state(ms_title);
        break;
    default:
        break;
    }
}

void howtoplay_timerh(void){
    draw_howtoplay();
}

