#ifndef HOWTOPLAY_DRAW_H
#define HOWTOPLAY_DRAW_H

#include "obj_draw.h"
#include "font.h"

typedef struct {
	char *key_str;
	char *description_game_str;
	char *description_menu_str;
	font_id_t *key_fontseq;
    font_id_t *description_game_fontseq;
    font_id_t *description_menu_fontseq;
} key_info_t;

typedef struct {
    char *name_str;
    char *description_str;
	int height;
    image_id_t img[2];
    int motion_interval, motion, motion_count;
    font_id_t *name_fontseq;
    font_id_t *description_fontseq;
} character_info_t;

typedef struct {
    char *name_str;
    char *description_str;
	int height;
    image_id_t img;
	void (*draw_func)(int, int);
    font_id_t *name_fontseq;
    font_id_t *description_fontseq;
} terran_info_t;


void howtoplay_draw_init(void);
void draw_howtoplay(void);
void draw_rule(void);
void draw_keys(void);
void draw_characters(void);
void draw_terrans(void);
void draw_terran_lift(int x, int y);

#endif
