#include <stdio.h>
#include <EzGraph.h>
#include "config.h"
#include "record.h"
#include "obj.h"


static record_info_t record_infos[] = {
//    {re_score, "ȤƤ", 1, 0},
    {re_time, "", 1, 0},
    {re_gondin_eaten, "", 1, 0},
    {re_gondin_lost, "", 0, 1},
//    {re_clear, "ꤢķ", 0, 1},
    {re_walk_frame, "", 0, 1},
    {re_jump_count, "ķ", 0, 1},
    {re_air_frame, "", 0, 1},
    {re_lift_frame, "", 0, 1},
    {re_blast_count, "", 0, 1},
    {re_killed_by_pierced, "", 0, 1},
    {re_killed_by_ojigiri, "", 0, 1},
    {re_killed_by_smash, "", 0, 1},
    {re_killed_by_flame, "", 0, 1},

    {re_hatopo_killed, "ȷ", 0, 1},
    {re_yaarashi_killed, "", 0, 1},
    {re_gagga_killed, "", 0, 1},
    {re_fwall_destroyed, "", 0, 1},
    {re_iwall_destroyed, "ɹ", 0, 1},
};

#define INFO_NUM (sizeof(record_infos)/sizeof(record_info_t))

static font_id_t info_icon_fontseqs[re_end][2];

static ot2re_info_t kill_ot2re_infos[] = {
	{ot_gondin, re_gondin_lost},
	{ot_hatopo, re_hatopo_killed},
	{ot_yaarashi, re_yaarashi_killed},
	{ot_gagga, re_gagga_killed},
	{ot_fwall, re_fwall_destroyed},
	{ot_iwall, re_iwall_destroyed},
//	{ot_, re__killed},
};
#define KILL_OT2RE_INFO_NUM (sizeof(kill_ot2re_infos)/sizeof(ot2re_info_t))

static record_entry_t kill_ot2re_table[ot_end];

void record_init(void){
    int i;
    for (i = 0 ; i < re_end ; i++){
        info_icon_fontseqs[i][0] = fi_end;
    }
    for (i = 0 ; i < INFO_NUM ; i++){
        printf("record init:%d\n", i);
        str2fontseq(record_infos[i].caption,
                    info_icon_fontseqs[record_infos[i].entry]);
    }
	for (i = 0 ; i < ot_end ; i++){
		kill_ot2re_table[i] = re_invalid;
	}
	for (i = 0 ; i < KILL_OT2RE_INFO_NUM ; i++){
		kill_ot2re_table[kill_ot2re_infos[i].type] = kill_ot2re_infos[i].entry;
	}
}

font_id_t *get_record_icon(record_entry_t re){
    return info_icon_fontseqs[re];
}

// infosϿ줿recordȥο֤
int get_record_showentry_num(void){
    return INFO_NUM;
}

record_info_t *get_record_info(int no){
    return &record_infos[no];
}

record_entry_t kill_ot2re(obj_type_t type){
	return kill_ot2re_table[type];
}
