#include <stdio.h>
#include <EzGraph.h>

#include "config.h"
#include "layout.h"
#include "draw.h"
#include "select_stage.h"
#include "select_stage_draw.h"
#include "obj_draw.h"
#include "font.h"

#define TLtx(x) ((x)*THUMB_XSKIP + THUMB_XOFFSET)
#define TLty(y) ((y)*THUMB_YSKIP + THUMB_YOFFSET)

static char *title_str = "ơ󤿤";
static font_id_t *title_fontseq;
static char *stage_unit_str = "";
static font_id_t *stage_unit_fontseq;
static char *score_unit_str = "Ƥ";
static font_id_t *score_unit_fontseq;

void select_stage_draw_init(void){
    title_fontseq = alloc_fontseq(title_str);
    stage_unit_fontseq = alloc_fontseq(stage_unit_str);
    score_unit_fontseq = alloc_fontseq(score_unit_str);
}

void draw_select_stage(stage_thumb_t stage_thumbs[], int stage_num,
                       int cursor_x, int cursor_y, int line)
{
    int x, y, si, i;
    font_id_t no_fontseq[STAGE_NUM_LEN+1];
    font_id_t score_fontseq[SCORE_LEN+1];

    uint2fontseq(line*THUMB_COL_NUM, STAGE_NUM_LEN, no_fontseq);
    draw_fontseq((WIN_WIDTH-16*9)/2, 8, title_fontseq);
    for (y = 0 ; y < THUMB_ROW_NUM ; y++){
        for (x = 0 ; x < THUMB_COL_NUM ; x++){
            si = CursorPos2StageIx(x, y, line);
            if (si < stage_num){
                SetColor(7);
                inc_fontseq(STAGE_NUM_LEN, no_fontseq);
                draw_fontseq(TLtx(x), TLty(y)-32,
			  				stage_thumbs[si].stars_fontseq);
				uint2fontseq(stage_thumbs[si].top_score, 5, score_fontseq);
                draw_fontseq(TLtx(x)+THUMB_WIDTH-16*(STAGE_NUM_LEN), TLty(y)-32,
                             no_fontseq);
//                draw_fontseq(TLtx(x)+THUMB_WIDTH-16*(STAGE_NUM_LEN+2), TLty(y)-32,
//                             no_fontseq);
//                draw_fontseq(TLtx(x)+THUMB_WIDTH-16*2, TLty(y)-32,
//                             stage_unit_fontseq);
                draw_fontseq(TLtx(x)+THUMB_WIDTH-16*(SCORE_LEN+2), TLty(y)-16,
                             score_fontseq);
                draw_fontseq(TLtx(x)+THUMB_WIDTH-16*2, TLty(y)-16,
                             score_unit_fontseq);
                draw_stage_thumb(&stage_thumbs[si], TLtx(x), TLty(y));
                for (i = 0 ; i < STAGE_TITLE_ROW_NUM ; i++){
                    draw_fontseq(TLtx(x), TLty(y)+THUMB_HEIGHT+i*LINESKIP+8,
                                 stage_thumbs[si].title[i]);
                }
#ifdef DEBUG
                //                EzDrawStringB(TLtx(x), TLty(y)+64, get_stage_filename(si));
#endif
            }
        }
    }
    //    draw_img(ii_chee_wl0, 
    draw_img(ii_chee_back, 
             (TLtx(cursor_x)+THUMB_WIDTH/2-16)>>DRAW_SCALE_SHIFT, 
             (TLty(cursor_y)+THUMB_HEIGHT/2-16)>>DRAW_SCALE_SHIFT);
//             (TLty(cursor_y)+THUMB_HEIGHT+48)>>DRAW_SCALE_SHIFT);
    EzShowBuffer();
}

void draw_stage_thumb(stage_thumb_t *thumb, int ltx, int lty){
	int x, y;
    for (y = 0 ; y < MAP_GRID_HEIGHT ; y++){
        for (x = 0 ; x < MAP_GRID_WIDTH ; x++){
			SetColor(GetThumbColor(x, y));
			EzFillBoxB(x*4+ltx, y*4+lty, x*4+3+ltx, y*4+3+lty);
		}
	}
}
