#include <stdio.h>
#include <EzGraph.h>
#include "config.h"
#include "font.h"
#include "record.h"
#include "select_stage.h"
#include "select_stage_draw.h"
#include "stage_info_draw.h"

static char *title_str = "ơ%d ";
static font_id_t title_fontseq[4+STAGE_NO_LEN+STAGE_TITLE_WIDTH*STAGE_TITLE_ROW_NUM+1];
static char *score_str = "ȤƤ%d %dꤢ";
static font_id_t score_fontseq[4+10+10+5+1];

static int stage_no;
static stage_thumb_t *stage_thumb;
static int info_num;

static font_id_t info_fontseqs[re_end][80];

void stage_info_draw_init(void){
    info_num = get_record_showentry_num();
}

void setup_stage_info_draw(void){
    int i;
    record_info_t *record_info;
    record_entry_t entry;
    char buf[256];

    stage_no = get_current_stage_no();
    stage_thumb = get_current_thumb();

    sprintf(buf, title_str, stage_no);
    str2fontseq(buf, title_fontseq);
    printf("setup stage_info stage_no:%d\n", stage_no);
    for (i = 0 ; i < STAGE_TITLE_ROW_NUM ; i++){
		fontseq_cat(title_fontseq, stage_thumb->title[i]);
    }
    sprintf(buf, score_str,
		get_current_stage_record_max(re_score),
		get_current_stage_record_sum(re_clear));
   str2fontseq(buf, score_fontseq);
   for (i = 0 ; i < info_num ; i++){
       record_info = get_record_info(i);
       entry = record_info->entry;
       sprintf(buf, "%s %4d%4d %8d",
               record_info->caption,
               get_current_stage_record_min(entry),
               get_current_stage_record_max(entry),
               get_current_stage_record_sum(entry)
               );
       puts(buf);
       str2fontseq(buf, info_fontseqs[i]);
    }
}

void draw_stage_info(void){
    int i;

    draw_fontseq(8, 0, title_fontseq);
    draw_fontseq(8, 20, score_fontseq);

    draw_stage_thumb(stage_thumb, 500, 8);

	if (get_current_stage_record_sum(re_clear) > 0){
        for (i = 0 ; i < info_num ; i++){
            draw_fontseq(8, 20+LINESKIP+i*LINESKIP, info_fontseqs[i]);
		}
	}
    EzShowBuffer();
}
