#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <EzGraph.h>
#include "config.h"
#include "main.h"
#include "title.h"
#include "select_stage.h"
#include "stage.h"
#include "draw.h"
#include "title_draw.h"


static title_menuitem_t cursor_pos;

void title_init(void){
    cursor_pos = ti_game;
}

void setup_title(void){
    EzSetKeyHandler(title_keyh);
    EzSetKeyReleaseHandler(title_key_releaseh);
    EzSetTimerHandler(title_timerh, GAME_SPEED);
}

void title_keyh(int key){
    switch (key){
    case EZ_Left:
    case EZ_Up:
        cursor_pos = (cursor_pos + ti_end - 1) % ti_end;
        break;
    case EZ_Right:
    case EZ_Down:
        cursor_pos = (cursor_pos + 1) % ti_end;
        break;
    default:
        break;
    }
}

void title_key_releaseh(int key){
    switch (key){
    case ' ':
    case EZ_Return:
        switch (cursor_pos){
        case ti_game:
            set_main_state(ms_select_stage);
            break;
//        case ti_editor:
//            puts("editor not implemented yet.");
//            puts("start game for test");
//            load_current_stage(TEST_STAGE, 1);
//            set_main_state(ms_game);
//            break;
        case ti_howtoplay:
            puts("how to play");
            set_main_state(ms_howtoplay);
            break;
//        case ti_config:
//            puts("config");
//            break;
        case ti_quit:
            set_main_state(ms_quit);
            break;
        default:
            assert(0);
            exit(1);
        }
    default:
        break;
    }
}

void title_timerh(void){
    draw_title();
}

title_menuitem_t get_title_cursor_pos(void){
    return cursor_pos;
}
